/*
 */

import java.awt.*;
import java.util.*;
import java.net.*;
import java.io.*;

public class ShootingForDummiesClientApplet extends BufferedApplet {

    pList ships = new pList();
    pList plasma = new pList();
    DatagramSocket sock = null;
    InetAddress servip = null;
    int servport = 12345;

    /**
     * initialize things
     */
    public void init(){
        super.init();
        try{
            servip = InetAddress.getByName("localhost");

            // create a socket to send data.
            sock = new DatagramSocket();
        }catch(IOException e){
        }
    }

    public void drawShip(Graphics g,Ship s){
        /*
        double[] xs = {-1,2,2,-1};
        double[] ys = {1,1,-1,-1};

        for(int i=0;i<xs.length;i++){
            xs[i]*=10;
            ys[i]*=10;
        }

        // rotate and translate. 
        int[] tx = new int[xs.length];
        int[] ty = new int[ys.length];
        // cos, -sin
        // sin, cos
        double sin = Math.sin(direction);
        double cos = Math.cos(direction);
        for(int i=0;i<xs.length;i++){
            tx[i] = (int)
                (x + (cos * xs[i] + -sin * ys[i]));
            ty[i] = (int)
                (y + (sin * xs[i] + cos * ys[i]));
            ty[i] = ty[i] * -1 + h;
        }
        g.setColor(Color.red);
        g.fillPolygon(tx,ty,tx.length);
        g.setColor(Color.black);
        g.drawPolygon(tx,ty,tx.length);
        */

    }


    /**
     * function that gets called whenever something needs to be
     * rendered.
     */
    public void render(Graphics g) {
        // clear screen
        g.setColor(Color.lightGray);
        g.fillRect(0, 0, bounds().width, bounds().height);

        for(int i=0;i<ships.size();i++){
            Ship s = (Ship)ships.get(i);
            drawShip(g,s);
        }
        for(int i=0;i<plasma.size();i++){
            Plasma p = (Plasma)plasma.get(i);   
            g.setColor(Color.yellow);
            g.fillRect((int)(p.x-2),(int)((p.y-2) * -1 + bounds().height),5,5);            
        }
        
    }

    public boolean keyDown(Event evt,int key){
        System.out.println("keyDown: "+key);
        if(key < 0x1000){

            // send: name,color,key
            String ourStrData = ""+"Bob"+","+0+","+key+"\n";
            // data bytes to send.
            byte[] ourOutData = ourStrData.getBytes();
            
            DatagramPacket p = new DatagramPacket(ourOutData, ourOutData.length,servip,servport);
            try{
                sock.send(p);
            }catch(IOException e){ }
        }

        return true;
    }

    public boolean keyUp(Event evt,int key){
        System.out.println("keyUp: "+key);
        if(key < 0x1000){

            // send: name,color,key
            String ourStrData = ""+"Bob"+","+0+","+(-key)+"\n";
            // data bytes to send.
            byte[] ourOutData = ourStrData.getBytes();
            
            DatagramPacket p = new DatagramPacket(ourOutData, ourOutData.length,servip,servport);
            try{
                sock.send(p);
            }catch(IOException e){ }
        }

        return true;
    }
}

